.ident  "../sha512-ia64.s, version 1.0"
.ident  "IA-64 ISA artwork by Andy Polyakov <appro@fy.chalmers.se>"
.explicit
.text

prsave=r14;
K=r15;
A=r16;	B=r17;	C=r18;	D=r19;
E=r20;	F=r21;	G=r22;	H=r23;
T1=r24;	T2=r25;
s0=r26;	s1=r27;	t0=r28;	t1=r29;
Ktbl=r30;
ctx=r31;	// 1st arg
input=r48;	// 2nd arg
num=r49;	// 3rd arg
sgm0=r50;	sgm1=r51;	// small constants

// void sha512_block (SHA_CTX *ctx, const void *in,size_t num[,int host])
.global	sha512_block#
.proc	sha512_block#
.align	32
sha512_block:
	.prologue
	.fframe	0
	.save	ar.pfs,r2
	.save	ar.lc,r3
	.save	pr,prsave
{ .mmi;	alloc	r2=ar.pfs,3,17,0,16
	add	ctx=0,r32		// 1st arg
	mov	r3=ar.lc	}
{ .mmi;	add	input=0,r33		// 2nd arg
	addl	Ktbl=@ltoff(K512#),gp
	mov	prsave=pr	};;

	.body
{ .mii;	ld8	Ktbl=[Ktbl]
	mov	num=r34		};;	// 3rd arg

{ .mib;	add	r8=0*8,ctx
	add	r9=1*8,ctx
	brp.loop.imp	.L_first16,.L_first16_ctop
				}
{ .mib;	add	r10=2*8,ctx
	add	r11=3*8,ctx
	brp.loop.imp	.L_rest,.L_rest_ctop
				};;
// load A-H
{ .mmi;	ld8	A=[r8],4*8
	ld8	B=[r9],4*8
	mov	sgm0=7	}
{ .mmi;	ld8	C=[r10],4*8
	ld8	D=[r11],4*8
	mov	sgm1=6	};;
{ .mmi;	ld8	E=[r8]
	ld8	F=[r9]		}
{ .mmi;	ld8	G=[r10]
	ld8	H=[r11]
	cmp.ne	p15,p14=0,r35	};;	// used in sha256_block

.L_outer:
{ .mii;	mov	ar.lc=15
	mov	ar.ec=1		};;
.align	32
.L_first16:
.rotr	X[16]
{ .mmi;		ld8	X[15]=[input],8	// X[i]=*input++
		and	T1=F,E
		and	T2=A,B		}
{ .mmi;		ld8	K=[Ktbl],8
		andcm	r8=G,E
		and	r9=A,C		};;
{ .mmi;		xor	T1=T1,r8		//T1=((e & f) ^ (~e & g))
		and	r10=B,C
		shrp	r11=E,E,14 }	// ROTR(e,14)
{ .mmi;		xor	T2=T2,r9
		mux1	X[15]=X[15],@rev };;	// eliminated in big-endian
{ .mib;		add	T1=T1,H			// T1=Ch(e,f,g)+h
		shrp	r8=E,E,18 }	// ROTR(e,18)
{ .mib;		xor	T2=T2,r10		// T2=((a & b) ^ (a & c) ^ (b & c))
		mov	H=G		};;
{ .mib;		xor	r11=r8,r11
		shrp	r9=E,E,41 }	// ROTR(e,41)
{ .mib;		mov	G=F
		mov	F=E		};;
{ .mib;		xor	r9=r9,r11		// r9=Sigma1(e)
		shrp	r10=A,A,28 }	// ROTR(a,28)
{ .mib;		add	T1=T1,K			// T1=Ch(e,f,g)+h+K512[i]
		mov	E=D		};;
{ .mib;		add	T1=T1,r9		// T1+=Sigma1(e)
		shrp	r11=A,A,34 }	// ROTR(a,34)
{ .mib;		mov	D=C
		mov	C=B		};;
{ .mib;		add	T1=T1,X[15]		// T1+=X[i]
		shrp	r8=A,A,39 }	// ROTR(a,39)
{ .mib;		xor	r10=r10,r11
		nop.i	 0x0 };;	// eliminated in 64-bit
{ .mmi;		xor	r10=r8,r10		// r10=Sigma0(a)
		mov	B=A
		add	A=T1,T2		};;
.L_first16_ctop:
{ .mib;		add	E=E,T1
		add	A=A,r10			// T2=Maj(a,b,c)+Sigma0(a)
	br.ctop.sptk	.L_first16	};;

{ .mib;	mov	ar.lc=80-17	}
{ .mib;	mov	ar.ec=1			};;
.align	32
.L_rest:
.rotr	X[16]
{ .mib;		ld8	K=[Ktbl],8
		shrp	r8=X[15-1],X[15-1],1 }	// ROTR(s0,1)
{ .mib; 	add	X[15]=X[15],X[15-9]	// X[i&0xF]+=X[(i+9)&0xF]
		shr.u	s0=X[15-1],sgm0	};;	// s0=X[(i+1)&0xF]>>7
{ .mib;		and	T1=F,E
		shrp	r9=X[15-1],X[15-1],8 }	// ROTR(s0,8)
{ .mib;		andcm	r10=G,E
		shr.u	s1=X[15-14],sgm1 };;	// s1=X[(i+14)&0xF]>>6
{ .mmi;		xor	T1=T1,r10		// T1=((e & f) ^ (~e & g))
		xor	r9=r8,r9
		shrp	r10=X[15-14],X[15-14],19 };;// ROTR(s1,19)
{ .mib;		and	T2=A,B		
		shrp	r11=X[15-14],X[15-14],61 }// ROTR(s1,61)
{ .mib;		and	r8=A,C		};;
{ .mib;		xor	s0=s0,r9		// s0=sigma0(X[(i+1)&0xF])
		shrp	r9=E,E,14 }	// ROTR(e,14)
{ .mib;		xor	r10=r11,r10
		xor	T2=T2,r8	};;
{ .mib;		xor	s1=s1,r10		// s1=sigma1(X[(i+14)&0xF])
		add	T1=T1,H		}
{ .mib;		and	r10=B,C
		add	X[15]=X[15],s0	};;	// X[i&0xF]+=sigma0(X[(i+1)&0xF])
{ .mmi;		xor	T2=T2,r10		// T2=((a & b) ^ (a & c) ^ (b & c))
		mov	H=G
		shrp	r8=E,E,18 };;	// ROTR(e,18)
{ .mmi;		xor	r11=r8,r9
		add	X[15]=X[15],s1		// X[i&0xF]+=sigma1(X[(i+14)&0xF])
		shrp	r9=E,E,41 }	// ROTR(e,41)
{ .mmi;		mov	G=F
		mov	F=E		};;
{ .mib;		xor	r9=r9,r11		// r9=Sigma1(e)
		shrp	r10=A,A,28 }	// ROTR(a,28)
{ .mib;		add	T1=T1,K			// T1=Ch(e,f,g)+h+K512[i]
		mov	E=D		};;
{ .mib;		add	T1=T1,r9		// T1+=Sigma1(e)
		shrp	r11=A,A,34 }	// ROTR(a,34)
{ .mib;		mov	D=C
		mov	C=B		};;
{ .mmi;		add	T1=T1,X[15]		// T1+=X[i]
		xor	r10=r10,r11
		shrp	r8=A,A,39 };;	// ROTR(a,39)
{ .mmi;		xor	r10=r8,r10		// r10=Sigma0(a)
		mov	B=A
		add	A=T1,T2		};;
.L_rest_ctop:
{ .mib;		add	E=E,T1
		add	A=A,r10			// T2=Maj(a,b,c)+Sigma0(a)
	br.ctop.sptk	.L_rest	};;

{ .mib;	add	r8=0*8,ctx
	add	r9=1*8,ctx		}
{ .mib;	add	r10=2*8,ctx
	add	r11=3*8,ctx		};;
{ .mmi;	ld8	r32=[r8],4*8
	ld8	r33=[r9],4*8		}
{ .mmi;	ld8	r34=[r10],4*8
	ld8	r35=[r11],4*8
	cmp.ltu	p6,p7=1,num		};;
{ .mmi;	ld8	r36=[r8],-4*8
	ld8	r37=[r9],-4*8
(p6)	add	Ktbl=-8*80,Ktbl	}
{ .mmi;	ld8	r38=[r10],-4*8
	ld8	r39=[r11],-4*8
(p7)	mov	ar.lc=r3		};;
{ .mmi;	add	A=A,r32
	add	B=B,r33
	add	C=C,r34			}
{ .mmi;	add	D=D,r35
	add	E=E,r36
	add	F=F,r37			};;
{ .mmi;	st8	[r8]=A,4*8
	st8	[r9]=B,4*8
	add	G=G,r38			}
{ .mmi;	st8	[r10]=C,4*8
	st8	[r11]=D,4*8
	add	H=H,r39			};;
{ .mmi;	st8	[r8]=E
	st8	[r9]=F
(p6)	add	num=-1,num		}
{ .mmb;	st8	[r10]=G
	st8	[r11]=H
(p6)	br.dptk.many	.L_outer	};;

{ .mib;	mov	pr=prsave,0x1ffff
	br.ret.sptk.many	b0	};;
.endp	sha512_block#
.align	64
.type	K512#,@object
K512:	data8	0x428a2f98d728ae22,0x7137449123ef65cd
	data8	0xb5c0fbcfec4d3b2f,0xe9b5dba58189dbbc
	data8	0x3956c25bf348b538,0x59f111f1b605d019
	data8	0x923f82a4af194f9b,0xab1c5ed5da6d8118
	data8	0xd807aa98a3030242,0x12835b0145706fbe
	data8	0x243185be4ee4b28c,0x550c7dc3d5ffb4e2
	data8	0x72be5d74f27b896f,0x80deb1fe3b1696b1
	data8	0x9bdc06a725c71235,0xc19bf174cf692694
	data8	0xe49b69c19ef14ad2,0xefbe4786384f25e3
	data8	0x0fc19dc68b8cd5b5,0x240ca1cc77ac9c65
	data8	0x2de92c6f592b0275,0x4a7484aa6ea6e483
	data8	0x5cb0a9dcbd41fbd4,0x76f988da831153b5
	data8	0x983e5152ee66dfab,0xa831c66d2db43210
	data8	0xb00327c898fb213f,0xbf597fc7beef0ee4
	data8	0xc6e00bf33da88fc2,0xd5a79147930aa725
	data8	0x06ca6351e003826f,0x142929670a0e6e70
	data8	0x27b70a8546d22ffc,0x2e1b21385c26c926
	data8	0x4d2c6dfc5ac42aed,0x53380d139d95b3df
	data8	0x650a73548baf63de,0x766a0abb3c77b2a8
	data8	0x81c2c92e47edaee6,0x92722c851482353b
	data8	0xa2bfe8a14cf10364,0xa81a664bbc423001
	data8	0xc24b8b70d0f89791,0xc76c51a30654be30
	data8	0xd192e819d6ef5218,0xd69906245565a910
	data8	0xf40e35855771202a,0x106aa07032bbd1b8
	data8	0x19a4c116b8d2d0c8,0x1e376c085141ab53
	data8	0x2748774cdf8eeb99,0x34b0bcb5e19b48a8
	data8	0x391c0cb3c5c95a63,0x4ed8aa4ae3418acb
	data8	0x5b9cca4f7763e373,0x682e6ff3d6b2b8a3
	data8	0x748f82ee5defb2fc,0x78a5636f43172f60
	data8	0x84c87814a1f0ab72,0x8cc702081a6439ec
	data8	0x90befffa23631e28,0xa4506cebde82bde9
	data8	0xbef9a3f7b2c67915,0xc67178f2e372532b
	data8	0xca273eceea26619c,0xd186b8c721c0c207
	data8	0xeada7dd6cde0eb1e,0xf57d4f7fee6ed178
	data8	0x06f067aa72176fba,0x0a637dc5a2c898a6
	data8	0x113f9804bef90dae,0x1b710b35131c471b
	data8	0x28db77f523047d84,0x32caab7b40c72493
	data8	0x3c9ebe0a15c9bebc,0x431d67c49c100d4c
	data8	0x4cc5d4becb3e42b6,0x597f299cfc657e2a
	data8	0x5fcb6fab3ad6faec,0x6c44198c4a475817
.size	K512#,8*80
